		.equ	sp, s15

		.rodata
__data_init_base:
		.space	__data_end - __data_begin


		.bss
stack:		.space	32


		.text
		.org	0x000

	; --------------------------------------------------------------------
	; Boot code
	; --------------------------------------------------------------------
_entry:
		; Init stack pointer
		load	sp, stack

		; Clear bss
		load	s0, __bss_begin
		load	s1, 0x00
1:
		store	s1, (s0)
		add	s0, 1
		compare	s0, __bss_end
		jump	nz, 1b

		; Init data (from rodata)
		load	s0, __data_begin
		load	s1, __data_init_base
1:
		fetch	s2, (s1)
		store	s2, (s0)
		add	s0, 1
		add	s1, 1
		compare	s0, __data_end
		jump	nz, 1b

		jump	main

